package cz.upol.jj2.lab03;

import java.util.Scanner;

/**
 * s lehkymi upravami prevzato od Petra Krajci
 */
public class BankStressTest implements Runnable {

	private static final int ITERATIONS = 5000;

	private Bank bank;

	public BankStressTest(Bank bank) {
		this.bank = bank;
	}

	public void run() {
		for (int i = 0; i < ITERATIONS; i++) {
			bank.transfer(1, 2, 42);
			bank.transfer(5, 5, 88);
			bank.transfer(2, 3, 123);
			bank.transfer(3, 4, 666);
			bank.transfer(4, 1, 24);
		}
	}

	public static void main(String[] args) throws Exception {
		Bank bank;
		Scanner s = new Scanner(System.in);
		System.out.println("Zadejte typ synchronizace vlaken banky: bez, metody, objekt:");
		String synchroType = s.next();
		bank = switch(synchroType) {
			case "bez" -> new Bank1("Nesynchronizovana", 6);
			case "metody" -> new Bank2("Synchronizovane metody", 6);
			case "objekt" -> new Bank3("Synchronizovany objekt", 6);
			default -> throw new Exception("Nejsem banka, ...");
		};
		System.out.println("Zadejte pocet vlaken: ");
		int threadCount = s.nextInt();
		Thread[] threads = new Thread[threadCount];

		for (int i = 0; i < threadCount; i++) 
			threads[i] = new Thread(new BankStressTest(bank));

		for (Thread t: threads)
			t.start();

		for (Thread t: threads)
			t.join();

		System.out.println("Soucet vsech dluhu a prebytku: " + bank.summary()); //pri spravnem prubehu 0
		// u nesynchronizovane verze se mohou nejake penize "ztratit" nebo "objevit z niceho"
	}
}
